package com.zhongzheng.modules.pay.service.impl;

import cn.hutool.core.bean.BeanUtil;
import cn.hutool.core.util.StrUtil;
import com.baomidou.mybatisplus.core.toolkit.CollectionUtils;
import com.zhongzheng.common.utils.DateUtils;
import com.zhongzheng.modules.pay.domain.PayAisle;
import com.zhongzheng.modules.pay.domain.PaySupply;
import org.springframework.stereotype.Service;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import com.baomidou.mybatisplus.core.toolkit.Wrappers;
import com.github.pagehelper.Page;
import com.zhongzheng.modules.pay.bo.PayVisitAddBo;
import com.zhongzheng.modules.pay.bo.PayVisitQueryBo;
import com.zhongzheng.modules.pay.bo.PayVisitEditBo;
import com.zhongzheng.modules.pay.domain.PayVisit;
import com.zhongzheng.modules.pay.mapper.PayVisitMapper;
import com.zhongzheng.modules.pay.vo.PayVisitVo;
import com.zhongzheng.modules.pay.service.IPayVisitService;

import java.util.ArrayList;
import java.util.Collection;
import java.util.Collections;
import java.util.List;
import java.util.stream.Collectors;

/**
 * 到访校区Service业务层处理
 *
 * @author ruoyi
 * @date 2021-10-12
 */
@Service
public class PayVisitServiceImpl extends ServiceImpl<PayVisitMapper, PayVisit> implements IPayVisitService {

    @Override
    public PayVisitVo queryById(Long visitId){
        PayVisit db = this.baseMapper.selectById(visitId);
        return BeanUtil.toBean(db, PayVisitVo.class);
    }

    @Override
    public List<PayVisitVo> queryList(PayVisitQueryBo bo) {
        LambdaQueryWrapper<PayVisit> lqw = Wrappers.lambdaQuery();
        lqw.like(StrUtil.isNotBlank(bo.getVisitName()), PayVisit::getVisitName, bo.getVisitName());
        lqw.in(bo.getStatus() != null, PayVisit::getStatus, bo.getStatus());
        lqw.orderByDesc(PayVisit::getUpdateTime);
        return entity2Vo(this.list(lqw));
    }

    /**
    * 实体类转化成视图对象
    *
    * @param collection 实体类集合
    * @return
    */
    private List<PayVisitVo> entity2Vo(Collection<PayVisit> collection) {
        List<PayVisitVo> voList = collection.stream()
                .map(any -> BeanUtil.toBean(any, PayVisitVo.class))
                .collect(Collectors.toList());
        if (collection instanceof Page) {
            Page<PayVisit> page = (Page<PayVisit>)collection;
            Page<PayVisitVo> pageVo = new Page<>();
            BeanUtil.copyProperties(page,pageVo);
            pageVo.addAll(voList);
            voList = pageVo;
        }
        return voList;
    }

    @Override
    public Boolean insertByAddBo(PayVisitAddBo bo) {
        PayVisit add = BeanUtil.toBean(bo, PayVisit.class);
        LambdaQueryWrapper<PayVisit> lqw = Wrappers.lambdaQuery();
        lqw.eq(StrUtil.isNotBlank(bo.getVisitName()), PayVisit::getVisitName, bo.getVisitName());
        List<Integer> status = new ArrayList<>();
        status.add(1);
        status.add(0);
        lqw.in(bo.getStatus() != null, PayVisit::getStatus, status);
        List<PayVisit> list = this.list(lqw);
        if (CollectionUtils.isNotEmpty(list)){
            throw new RuntimeException("重复到访校区名字");
        }
        validEntityBeforeSave(add);
        add.setCreateTime(DateUtils.getNowTime());
        add.setUpdateTime(DateUtils.getNowTime());
        return this.save(add);
    }

    @Override
    public Boolean updateByEditBo(PayVisitEditBo bo) {
        PayVisit update = BeanUtil.toBean(bo, PayVisit.class);
        LambdaQueryWrapper<PayVisit> lqw = Wrappers.lambdaQuery();
        lqw.eq(StrUtil.isNotBlank(bo.getVisitName()), PayVisit::getVisitName, bo.getVisitName());
        lqw.like(bo.getVisitId()!= null, PayVisit::getVisitId, bo.getVisitId());
        List<PayVisit> list = this.list(lqw);
        if (CollectionUtils.isEmpty(list)){
            lqw.clear();
            lqw.eq(StrUtil.isNotBlank(bo.getVisitName()), PayVisit::getVisitName, bo.getVisitName());
            List<Integer> status = new ArrayList<>();
            status.add(1);
            status.add(0);
            lqw.in(bo.getStatus() != null, PayVisit::getStatus, status);
            List<PayVisit> list1 = this.list(lqw);
            if (CollectionUtils.isNotEmpty(list1)){
                throw new IllegalArgumentException("重复到访校区名字");
            }
        }
        validEntityBeforeSave(update);
        update.setUpdateTime(DateUtils.getNowTime());
        return this.updateById(update);
    }

    /**
     * 保存前的数据校验
     *
     * @param entity 实体类数据
     */
    private void validEntityBeforeSave(PayVisit entity){
        //TODO 做一些数据校验,如唯一约束
    }

    @Override
    public Boolean deleteWithValidByIds(Collection<Long> ids, Boolean isValid) {
        if(isValid){
            //TODO 做一些业务上的校验,判断是否需要校验
        }
        return this.removeByIds(ids);
    }
}
